--- suexec.h.bak	2003-01-21 13:41:10.000000000 +0100
+++ suexec.h	2003-01-21 13:59:04.000000000 +0100
@@ -62,6 +62,13 @@
 #define _SUEXEC_H
 
 /*
+ * PHP_PATH -- Defines where the php binary is located
+ */
+#ifndef PHP_PATH
+#define PHP_PATH "/usr/local/bin/php"
+#endif
+
+/*
  * HTTPD_USER -- Define as the username under which Apache normally
  *               runs.  This is the only user allowed to execute
  *               this program.
--- suexec.c.bak	2003-01-21 13:41:04.000000000 +0100
+++ suexec.c	2003-01-21 13:55:22.000000000 +0100
@@ -264,6 +264,7 @@
     char *cmd;              /* command to be executed    */
     char cwd[AP_MAXPATH];   /* current working directory */
     char dwd[AP_MAXPATH];   /* docroot working directory */
+    char fcmd[AP_MAXPATH];  /* full path to php binary   */
     struct passwd *pw;      /* password entry holder     */
     struct group *gr;       /* group entry holder        */
     struct stat dir_info;   /* directory info holder     */
@@ -514,11 +515,21 @@
         }
     }
 
-    if ((strncmp(cwd, dwd, strlen(dwd))) != 0) {
-        log_err("command not in docroot (%s/%s)\n", cwd, cmd);
-        exit(114);
+    /*
+     * Full path to php binary
+     */
+    strncpy(fcmd, cwd, sizeof(fcmd));
+    strncat(fcmd, "/", sizeof(fcmd) - strlen(fcmd));
+    strncat(fcmd, cmd, sizeof(fcmd) - strlen(fcmd));
+
+    if (strncmp(fcmd, PHP_PATH, strlen(PHP_PATH)) == 0) {
+            log_err("call for php (%s)\n", fcmd);
+    }
+    else if ((strncmp(cwd, dwd, strlen(dwd))) != 0) {
+            log_err("command not in docroot (%s/%s)\n", cwd, cmd);
+            exit(114);
     }
-
+    
     /*
      * Stat the cwd and verify it is a directory, or error out.
      */
@@ -563,10 +574,11 @@
      * Error out if the target name/group is different from
      * the name/group of the cwd or the program.
      */
-    if ((uid != dir_info.st_uid) ||
+    if (((uid != dir_info.st_uid) ||
         (gid != dir_info.st_gid) ||
         (uid != prg_info.st_uid) ||
-        (gid != prg_info.st_gid)) {
+        (gid != prg_info.st_gid)) &&
+        (strncmp(fcmd, PHP_PATH, strlen(PHP_PATH)) != 0)) {
         log_err("target uid/gid (%ld/%ld) mismatch "
                 "with directory (%ld/%ld) or program (%ld/%ld)\n",
                 uid, gid,
